
package java2.koz01.lab13;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

import org.apache.commons.io.input.BoundedInputStream;

import lombok.extern.log4j.Log4j2;

@Log4j2
public class Lab13Decrypt {

	public static void main(String[] args) throws InvalidKeyException,
		NoSuchAlgorithmException, NoSuchPaddingException, IOException,
		InvalidKeySpecException
	{

		KeyPairLoader keyPairLoader = new KeyPairLoader();
		KeyPair kp = keyPairLoader.load("keys.rsa");

		try (InputStream nis = new FileInputStream(args[0]);
				OutputStream os = new FileOutputStream(args[1]))
		{
			Cipher cipher = Cipher.getInstance("AES");
			Cipher aCipher = Cipher.getInstance("RSA");
			aCipher.init(Cipher.DECRYPT_MODE, kp.getPrivate());
			try (InputStream rsaIs = new CipherInputStream(
				new NoClosingFilterInputStream(new BoundedInputStream(nis, 256)),
				aCipher))
			{
				byte[] keyData = new byte[32];
				rsaIs.read(keyData);
				SecretKeySpec skp = new SecretKeySpec(keyData, "AES");
				cipher.init(Cipher.DECRYPT_MODE, skp);
			}
			try (InputStream is = new CipherInputStream(
				new NoClosingFilterInputStream(nis), cipher);)
			{
				byte[] buffer = new byte[1024];
				int len;
				while (-1 != (len = is.read(buffer))) {
					os.write(buffer, 0, len);
				}
			}
		}
		log.info("decrypted");
	}
}
