package java2.koz01.lab13;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.Cipher;
import javax.crypto.CipherOutputStream;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;

import lombok.extern.log4j.Log4j2;

@Log4j2
public class Lab13Encrypt {

	public static void main(String[] args) throws NoSuchAlgorithmException,
		IOException, NoSuchPaddingException, InvalidKeyException,
		InvalidKeySpecException
	{

		KeyPairLoader keyPairLoader = new KeyPairLoader();
		KeyPair kp = keyPairLoader.load("keys.rsa");
		KeyGenerator kg = KeyGenerator.getInstance("AES");
		kg.init(256);
		SecretKey sk = kg.generateKey();


		/*try (OutputStream os = Files.newOutputStream(Paths.get("secretkey.aes"))) {
			os.write(sk.getEncoded());
		}*/


		Cipher cipher = Cipher.getInstance("AES");
		cipher.init(Cipher.ENCRYPT_MODE, sk);
		// 1. argument - input
		// 2. argument - output
		byte[] buffer = new byte[1024];
		OutputStream nos;
		try (InputStream is = new FileInputStream(args[0]);
				OutputStream os = new CipherOutputStream(nos = new FileOutputStream(
					args[1]),
					cipher))
		{
			Cipher aCipher = Cipher.getInstance("RSA");
			aCipher.init(Cipher.ENCRYPT_MODE, kp.getPublic());
			log.info("size of key {}", sk.getEncoded().length);

			try (OutputStream rsaOs = new CipherOutputStream(
				new NoClosingFilterOutputStream(nos), aCipher))
			{
				rsaOs.write(sk.getEncoded());
			}
			int len;
			while (-1 != (len = is.read(buffer))) {
				os.write(buffer, 0, len);
			}
		}
		log.info("encryption done!");
	}
}
