package java2.koz01.lab13;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.RSAPrivateKeySpec;
import java.security.spec.RSAPublicKeySpec;

import lombok.extern.log4j.Log4j2;

@Log4j2
public class Lab13GenerateKeys {

	public static void main(String[] args) throws NoSuchAlgorithmException,
		IOException, InvalidKeySpecException
	{

		KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		kpg.initialize(2048);
		KeyPair kp = kpg.generateKeyPair();

		log.info("private: {}", kp.getPrivate());
		log.info("public: {}", kp.getPublic());
		KeyFactory kf = KeyFactory.getInstance("RSA");
		RSAPrivateKeySpec pri = kf.getKeySpec(kp.getPrivate(),
			RSAPrivateKeySpec.class);
		RSAPublicKeySpec pub = kf.getKeySpec(kp.getPublic(),
			RSAPublicKeySpec.class);

		try (BufferedWriter bw = Files.newBufferedWriter(Paths.get("keys.rsa"))) {
			bw.write(pub.getModulus().toString());
			bw.newLine();
			bw.write(pub.getPublicExponent().toString());
			bw.newLine();
			bw.write(pri.getPrivateExponent().toString());
		}
	}
}
