package java2.koz01.lab13;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Cipher;
import javax.crypto.CipherOutputStream;
import javax.crypto.NoSuchPaddingException;

import lombok.extern.log4j.Log4j2;

@Log4j2
public class OutputStreamApp {

	public static void main(String[] args) throws NoSuchAlgorithmException,
		NoSuchPaddingException, FileNotFoundException, IOException,
		InvalidKeyException
	{
		KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		kpg.initialize(2048);
		KeyPair kp = kpg.generateKeyPair();

		log.info("private: {}", kp.getPrivate());
		log.info("public: {}", kp.getPublic());
		Cipher cipher = Cipher.getInstance("RSA");
		cipher.init(Cipher.ENCRYPT_MODE, kp.getPublic());
		for (int i = 200; i < 257; i++) {
			try (OutputStream os = new CipherOutputStream(new FileOutputStream("out" +
				i + ".enc"), cipher))
			{
				byte[] data = new byte[i];
				os.write(data);
			}
		}
	}
}
